1000 REMark GENERAL PURPOSE FAST CARTRIDGE DUPLICATOR
1010 :
1020 REMark Copies all files from the source cartridge
1030 REMark specified and stores them on the destination
1040 REMark cartridge also specified. Note that the
1050 REMark destination cartridge must be formatted before
1060 REMark the "dupl" program is run. All microdrive
1070 REMark numbers from 1 to 8 are supported.
1080 :
1090 REMark This is the ultra-fast version using the
1100 REMark machine code extensions SPOOL and NUM_JOBS in
1110 REMark order to get very fast paralleled data transfer.
1120 REMark Requires the Fast_cartridge_duplicator_code to have been loaded
1130 REMark into the resident procedure area first.
1140 :
1150 :
1160 REMark Author   : Rob Sherratt
1170 REMark Date     : 27th Oct, 1984
1180 REMark Home tel : 0394 272782
1190 :
1200 :
1210 REMark The parameter "max_jobs" is a tuning parameter
1220 REMark which should be increased if you have a memory
1230 REMark expansion board fitted, so that the number of
1240 REMark SPOOLed jobs running in parallel may be increased.
1250 :
1260 max_jobs = 10
1270 DIM FiNAME$(50,50),fnum$(50),a$(4),S$(10),D$(10)
1280 :
1290 REMark The NUM_JOBS function counts the number of parallel
1300 REMark jobs running before we start. Later on we need to know
1310 REMark how many jobs this program has started up, and we have
1320 REMark to wait until they have all finished before files can
1330 REMark be closed from within SUPERBASIC.
1340 :
1350 initial_jobs = NUM_JOBS
1360 :
1370 REMark This is the main body of the control program, written
1380 REMark as a list of procedure calls (nearly) to help make it
1390 REMark self-documenting.
1400 :
1410 display_initial_text
1420 get_directory_on_file
1430 list_and_read_directory
1440 :
1450 REMark skip
1460 :
1470 REPeat copy_cartridges
1480   open_all_source_files
1490   open_all_destination_files
1500   spool_data_for_all_files
1510   :
1520   REMark When waiting for the SPOOL jobs to finish, it is
1530   REMark important not to hog the processor's time in the
1540   REMark "wait_till_done" loop. Hence the PAUSE 100 statement
1550   REMark which waits for 2 seconds.
1560   :
1570   REPeat wait_till_done
1580     current_jobs = NUM_JOBS
1590     IF current_jobs = initial_jobs THEN EXIT wait_till_done
1600     PAUSE 100
1610   END REPeat wait_till_done
1620   :
1630   close_all_files
1640   announce_completion
1650   IF again$ == "n" THEN EXIT copy_cartridges
1660   IF change$ == "y" THEN 
1670     display_initial_text
1680     get_directory_on_file
1690     list_and_read_directory
1700   END IF 
1710 END REPeat copy_cartridges
1720 STOP
1730 :
1740 REMark skip -------- end of main program ----------------
1750 :
1760 DEFine PROCedure display_initial_text
1770   WINDOW 512,256,0,0
1780   PAPER 0: CLS
1790   WINDOW 454,20,32,10
1800   INK 0: STRIP 7: CSIZE 1,1
1810   PRINT " Fast Cartridge Duplicator - ";
1820   PRINT "Rob Sherratt  ";
1830   CSIZE 2,1: PRINT "";
1840   CSIZE 1,1: PRINT " 1984 "
1850   WINDOW 450,226,32,30
1860   STRIP 4: INK 0: CSIZE 0,0
1870   PRINT " Copies files from the source      "
1880   PRINT " Cartridge and stores them on the  "
1890   PRINT " destination Cartridge.            "\\
1900   PAPER 0: INK 7
1910   get_drive_numbers
1920   PRINT "Do you want to copy all files ? ";
1930   all$ = GET_YN$
1940   PRINT "Do you want a beep when done  ? ";
1950   noise$ = GET_YN$
1960   PRINT "Do you want to format Mdv" &D$& "    ? ";
1970   formt$ = GET_YN$
1980   IF formt$ == "y" THEN 
1990     INPUT "What name for the Cartridge   ? ";name$
2000   END IF 
2010   PRINT \"Press any key when you are ready."\\
2020   PAUSE
2030 END DEFine display_initial_text
2040 :
2050 :
2060 :
2070 DEFine PROCedure get_drive_numbers
2080   REPeat drive_numbers
2090     PRINT "Source Cartridge number       ? ";:S$=INKEY$(-1)
2100     PRINT S$
2110     PRINT "Destination Cartridge number  ? ";:D$=INKEY$(-1)
2120     PRINT D$
2130     REMark Validate the drive numbers just entered
2140     fail = 0
2150     IF S$ < "1" OR S$ > "8" THEN fail = 1
2160     IF D$ < "1" OR D$ > "8" THEN fail = 1
2170     IF S$ = D$ THEN fail = 1
2180     IF fail THEN 
2190       PRINT
2200       PRINT "Invalid. Drive numbers may be"
2210       PRINT "in the range 1 to 8 and must"
2220       PRINT "not be equal. Please reenter."\\
2230     ELSE 
2240       EXIT drive_numbers
2250     END IF 
2260   END REPeat drive_numbers
2270 END DEFine get_drive_numbers
2280 :
2290 :
2300 :
2310 DEFine PROCedure get_directory_on_file
2320   IF formt$ == "y" THEN 
2330     format_destination
2340   ELSE 
2350     DELETE "Mdv"& D$ &"_dir_lst"
2360   END IF 
2370   OPEN_NEW #4,"Mdv"& D$ &"_dir_lst"
2380   DIR #4,"Mdv"& S$ &"_"
2390   CLOSE #4
2400 END DEFine get_directory_on_file
2410 :
2420 :
2430 :
2440 DEFine PROCedure list_and_read_directory
2450   CLS
2460   STRIP 4: INK 0
2470   PRINT "Directory list. ";
2480   IF all$ == "n" THEN 
2490     PRINT "Type ";
2500     STRIP 0: INK 7
2510     PRINT " y ";
2520     STRIP 4: INK 0
2530     PRINT " after   "\"each file if you want it printed.";
2540   END IF 
2550   STRIP 0: INK 7
2560   PRINT
2570   OPEN_IN #4,"Mdv"& D$ &"_dir_lst"
2580   n=0
2590   REPeat getfile
2600     INPUT #4, FiNAME$(n)
2610     IF n>1 THEN 
2620       PRINT n-1;" ";FiNAME$(n);
2630       FOR k = LEN(FiNAME$(n)) TO 20: PRINT " ";
2640         a$ = n - 1
2650       FOR k = LEN(a$) TO 4: PRINT " ";
2660       IF all$ == "n" THEN 
2670         PRINT ": ";
2680         fnum$(n) = GET_YN$
2690       ELSE 
2700         fnum$(n) = "y": PRINT
2710       END IF 
2720     ELSE 
2730       STRIP 2: PRINT FiNAME$(n);
2740       STRIP 0: PRINT
2750     END IF 
2760     IF EOF(#4) THEN EXIT getfile
2770     n=n+1
2780   END REPeat getfile
2790   nfiles = n
2800   CLOSE #4
2810   PRINT
2820   DELETE "Mdv"& D$ &"_dir_lst"
2830 END DEFine list_and_read_directory
2840 :
2850 REMark skip
2860 :
2870 DEFine PROCedure format_destination
2880   FORMAT "Mdv"& D$ &"_"& name$
2890 END DEFine format_destination
2900 :
2910 :
2920 :
2930 DEFine PROCedure open_all_source_files
2940   WINDOW 268,226,230,30
2950   PAPER 0: CLS: STRIP 2
2960   PRINT "Opening all source files      ... ";
2970   STRIP 0: PRINT
2980   source_chan = 10
2990   FOR n = 2 TO nfiles
3000     IF fnum$(n) == "y" THEN 
3010       OPEN_IN #source_chan,"Mdv"& S$ &"_"& FiNAME$(n)
3020       source_chan = source_chan + 1
3030     END IF 
3040   END FOR n
3050   last_source_chan = source_chan - 1
3060 END DEFine open_all_source_files
3070 :
3080 :
3090 :
3100 DEFine PROCedure open_all_destination_files
3110   STRIP 2: PRINT "Opening all destination files ... ";
3120   STRIP 0: PRINT
3130   dest_chan = last_source_chan + 1
3140   FOR n = 2 TO nfiles
3150     IF fnum$(n) == "y" THEN 
3160       IF formt$ == "n" THEN DELETE "Mdv"& D$ &"_"& FiNAME$(n)
3170       OPEN_NEW #dest_chan,"Mdv"& D$ &"_"& FiNAME$(n)
3180       dest_chan = dest_chan + 1
3190     END IF 
3200   END FOR n
3210   last_dest_chan = dest_chan - 1
3220 END DEFine open_all_destination_files
3230 :
3240 :
3250 :
3260 DEFine PROCedure close_all_files
3270   PRINT
3280   STRIP 2: PRINT "Closing all files             ... "
3290   FOR chan = 10 TO last_dest_chan
3300     CLOSE #chan
3310   END FOR chan
3320 END DEFine close_all_files
3330 :
3340 REMark skip
3350 :
3360 DEFine PROCedure spool_data_for_all_files
3370   dest_chan = last_source_chan + 1
3380   file_num = 2
3390   FOR source_chan = 10 TO last_source_chan
3400     REPeat get_file_number
3410       IF fnum$(file_num) == "y" THEN EXIT get_file_number
3420       IF file_num > nfiles      THEN EXIT get_file_number
3430       file_num = file_num + 1
3440     END REPeat get_file_number
3450     PRINT "Copying ";FiNAME$(file_num)
3460     file_num = file_num + 1
3470     SPOOL #source_chan TO #dest_chan
3480     dest_chan = dest_chan + 1
3490     REPeat wait_a_bit
3500       IF NUM_JOBS - initial_jobs < max_jobs THEN EXIT wait_a_bit
3510       PAUSE 50
3520     END REPeat wait_a_bit
3530   END FOR source_chan
3540 END DEFine spool_data_for_all_files
3550 :
3560 :
3570 :
3580 DEFine PROCedure close_all_files
3590   PRINT
3600   STRIP 2: PRINT "Closing all files             ... "
3610   FOR chan = 10 TO last_dest_chan
3620     CLOSE #chan
3630   END FOR chan
3640 END DEFine close_all_files
3650 :
3660 :
3670 :
3680 DEFine FuNction GET_YN$
3690   LOCal inp$
3700   REPeat get_inp
3710     REMark Flush keyboard buffer before using INKEY$
3720     inp$ = KEYROW(0)
3730     inp$ = INKEY$(-1)
3740     IF inp$ == "y" THEN EXIT get_inp
3750     IF inp$ == CHR$(10) THEN inp$ = "n"
3760     IF inp$ == " " THEN inp$ = "n"
3770     IF inp$ = "n" THEN EXIT get_inp
3780     BEEP 2000,5
3790   END REPeat get_inp
3800   PRINT inp$
3810   RETurn inp$
3820 END DEFine GET_YN$
3830 :
3840 REMark skip
3850 :
3860 DEFine PROCedure announce_completion
3870   STRIP 7: INK 0: CSIZE 2,1
3880   PRINT "FINISHED         "
3890   STRIP 0: INK 7: CSIZE 0,0
3900   IF noise$ == "y" THEN 
3910     BEEP 0,1,50,100,1,15
3920     PAUSE 100
3930   END IF 
3940   BEEP 5000,255
3950   PRINT "Do you want to do another copy ? ";
3960   again$ = GET_YN$
3970   IF again$ == "y" THEN 
3980     PRINT "Is it a different source cartridge ? ";
3990     change$ = GET_YN$
4000     IF change$ == "y" THEN ELSE 
4010       change$ = "n"
4020       PRINT "Do you want to format Mdv"; D$ ;"_ ? ";
4030       formt$ = GET_YN$
4040       PRINT "Press any key when you are ready ";:PAUSE
4050       IF formt$(1) == "y" THEN format_destination
4060     END IF 
4070   ELSE reset
4080   END IF 
4090 END DEFine announce_completion
4100 :
4110 :
4120 :
4130 DEFine PROCedure reset
4140   MODE 512
4150   PAPER #2,0: INK #2,7
4160   PAPER #1,2: INK #1,7
4170   PAPER #0,0: INK #0,7
4180   WINDOW #0,512,256,0,0
4190   CLS #0
4200   WINDOW #2,454,184,32,10
4210   WINDOW #1,218,184,268,10
4220   WINDOW #0,454,50,32,200
4230   BORDER #0,1,2
4240   CLS #0
4250   CSIZE #2,0,0
4260   CSIZE #1,0,0
4270   CSIZE #0,0,0
4280 END DEFine reset
